var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const phin = require("phin").defaults({ parse: "json", timeout: 12000 });
const API = (userId) => `https://api.brick-hill.com/v1/user/${userId}/value`;
function getPlayerValue(userId) {
    return __awaiter(this, void 0, void 0, function* () {
        const data = (yield phin({ url: API(userId) })).body;
        if (data.error) {
            return {
                'user_id': userId,
                'value': 0,
                'direction': 0
            };
        }
        else {
            return data;
        }
    });
}
module.exports = getPlayerValue;
