var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const { hexToDec } = require("../../util/color/colorModule").default;
function addBrickProperties(packet, brick) {
    return __awaiter(this, void 0, void 0, function* () {
        packet.write("uint32", brick.netId);
        packet.write("float", brick.position.x);
        packet.write("float", brick.position.y);
        packet.write("float", brick.position.z);
        packet.write("float", brick.scale.x);
        packet.write("float", brick.scale.y);
        packet.write("float", brick.scale.z);
        packet.write("uint32", hexToDec(brick.color));
        packet.write("float", brick.visibility);
        // Additional attributes
        let attributes = "";
        if (brick.rotation)
            attributes += "I";
        if (brick.shape)
            attributes += "B";
        if (brick.lightEnabled)
            attributes += "D";
        if (!brick.collision)
            attributes += "F";
        if (brick.clickable)
            attributes += "G";
        if (brick.model)
            attributes += "C";
        packet.write("string", attributes);
        for (let i = 0; i < attributes.length; i++) {
            const ID = attributes.charAt(i);
            switch (ID) {
                case "B":
                    packet.write("string", brick.shape);
                    break;
                case "D":
                    packet.write("uint32", hexToDec(brick.lightColor));
                    packet.write("uint32", brick.lightRange);
                    break;
                case "G":
                    packet.write("bool", brick.clickable);
                    packet.write("uint32", brick.clickDistance);
                    break;
                case "I":
                    packet.write("int32", brick.rotation.x);
                    packet.write("int32", brick.rotation.y);
                    packet.write("int32", brick.rotation.z);
                    break;
            }
        }
        // Write the asset data last.
        if (attributes.indexOf("C") !== -1)
            yield packet.writeAsset(brick.model);
        return packet;
    });
}
module.exports = addBrickProperties;
